{
    "$graph": [
        {
            "label": "cluster_blastp_wnode",
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMax": 5000
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entry": "${ var cs=0; var s=inputs.blastdb_dir.length-1; var as = cs; if(as >= s) {as = s }; return inputs.blastdb_dir[as]; }",
                            "writable": false
                        },
                        {
                            "entry": "${ var cs=1; var s=inputs.blastdb_dir.length-1; var as = cs; if(as >= s) {as = s }; return inputs.blastdb_dir[as]; }",
                            "writable": false
                        },
                        {
                            "entry": "${ var cs=0; var s=inputs.asn_cache.length-1; var as = cs; if(as >= s) {as = s }; return inputs.asn_cache[as]; }",
                            "writable": false
                        },
                        {
                            "entry": "${ var cs=1; var s=inputs.asn_cache.length-1; var as = cs; if(as >= s) {as = s }; return inputs.asn_cache[as]; }",
                            "writable": false
                        },
                        {
                            "entry": "$(inputs.lds2)",
                            "writable": true
                        },
                        {
                            "entry": "$(inputs.proteins)",
                            "writable": false
                        }
                    ]
                }
            ],
            "baseCommand": "cluster_blastp_wnode",
            "inputs": [
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "-align_filter"
                    },
                    "id": "#cluster_blastp_wnode.cwl/align_filter"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "-allow-intersection"
                    },
                    "id": "#cluster_blastp_wnode.cwl/allow_intersection"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "Directory"
                    },
                    "inputBinding": {
                        "prefix": "-asn-cache",
                        "itemSeparator": ","
                    },
                    "id": "#cluster_blastp_wnode.cwl/asn_cache"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-backlog"
                    },
                    "id": "#cluster_blastp_wnode.cwl/backlog"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "Directory"
                    },
                    "id": "#cluster_blastp_wnode.cwl/blastdb_dir"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "-comp_based_stats"
                    },
                    "id": "#cluster_blastp_wnode.cwl/comp_based_stats"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "-compart"
                    },
                    "id": "#cluster_blastp_wnode.cwl/compart"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-dbsize"
                    },
                    "id": "#cluster_blastp_wnode.cwl/dbsize"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-delay"
                    },
                    "id": "#cluster_blastp_wnode.cwl/delay"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "inputBinding": {
                        "prefix": "-evalue"
                    },
                    "id": "#cluster_blastp_wnode.cwl/evalue"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-extra-coverage"
                    },
                    "id": "#cluster_blastp_wnode.cwl/extra_coverage"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-input-jobs"
                    },
                    "id": "#cluster_blastp_wnode.cwl/input_jobs"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-lds2"
                    },
                    "id": "#cluster_blastp_wnode.cwl/lds2"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-max-jobs"
                    },
                    "id": "#cluster_blastp_wnode.cwl/max_jobs"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-max_target_seqs"
                    },
                    "id": "#cluster_blastp_wnode.cwl/max_target_seqs"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "-no-merge"
                    },
                    "id": "#cluster_blastp_wnode.cwl/no_merge"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "-nogenbank"
                    },
                    "id": "#cluster_blastp_wnode.cwl/nogenbank"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-ofmt"
                    },
                    "id": "#cluster_blastp_wnode.cwl/ofmt"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "output",
                    "inputBinding": {
                        "prefix": "-O"
                    },
                    "id": "#cluster_blastp_wnode.cwl/output_dir"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#cluster_blastp_wnode.cwl/proteins"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-seg"
                    },
                    "id": "#cluster_blastp_wnode.cwl/seg"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "-soft_masking"
                    },
                    "id": "#cluster_blastp_wnode.cwl/soft_masking"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-threshold"
                    },
                    "id": "#cluster_blastp_wnode.cwl/threshold"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-top-by-score"
                    },
                    "id": "#cluster_blastp_wnode.cwl/top_by_score"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "prefix": "-word_size"
                    },
                    "id": "#cluster_blastp_wnode.cwl/word_size"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-workers"
                    },
                    "id": "#cluster_blastp_wnode.cwl/workers"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "inputBinding": {
                        "prefix": "-workers-per-cpu"
                    },
                    "id": "#cluster_blastp_wnode.cwl/workers_per_cpu"
                }
            ],
            "id": "#cluster_blastp_wnode.cwl",
            "outputs": [
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "$(inputs.output_dir)"
                    },
                    "id": "#cluster_blastp_wnode.cwl/outdir"
                }
            ]
        },
        {
            "label": "gpx_qdump",
            "class": "CommandLineTool",
            "baseCommand": "gpx_qdump",
            "inputs": [
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "-input-path"
                    },
                    "id": "#gpx_qdump.cwl/input_path"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "output.asn",
                    "inputBinding": {
                        "prefix": "-output"
                    },
                    "id": "#gpx_qdump.cwl/output_name"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-unzip"
                    },
                    "id": "#gpx_qdump.cwl/unzip"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_name)"
                    },
                    "id": "#gpx_qdump.cwl/output"
                }
            ],
            "id": "#gpx_qdump.cwl"
        },
        {
            "label": "gpx_qsubmit",
            "doc": "This workflow is specialized for the case when there is an LDS2 input  LDS2 is a _reference_ object, the kind that CWL does not like we need to provide actual input: proteins which matches the name of ASN.1 object references in LDS2 Another limitation is that it can handle no more than two item arrays in blastdb_dir and asn_cache Workaround used so far: in:\n  proteins:\n    default:\n        class: File\n        path: '/dev/null'\n        basename: 'null'\n        contents: ''\n",
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entry": "$(inputs.proteins)",
                            "writable": false
                        },
                        {
                            "entry": "${ var cs=0; var s=inputs.blastdb_dir.length-1; var as = cs; if(as >= s) {as = s }; return inputs.blastdb_dir[as]; }",
                            "writable": false
                        },
                        {
                            "entry": "${ var cs=1; var s=inputs.blastdb_dir.length-1; var as = cs; if(as >= s) {as = s }; return inputs.blastdb_dir[as]; }",
                            "writable": false
                        },
                        {
                            "entry": "${ var cs=0; var s=inputs.asn_cache.length-1; var as = cs; if(as >= s) {as = s }; return inputs.asn_cache[as]; }",
                            "writable": false
                        },
                        {
                            "entry": "${ var cs=1; var s=inputs.asn_cache.length-1; var as = cs; if(as >= s) {as = s }; return inputs.asn_cache[as]; }",
                            "writable": false
                        },
                        {
                            "entryname": "ids.mft",
                            "entry": "${var blob = '# ids.mft created for gpx_qsubmit from input ids Array of Files\\n';for (var i = 0; i < inputs.ids.length; i++) {blob += inputs.ids[i].path  + '\\n';}return blob;}"
                        }
                    ]
                }
            ],
            "baseCommand": "gpx_qsubmit",
            "inputs": [
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-NxM-threshold"
                    },
                    "id": "#gpx_qsubmit.cwl/NxM_threshold"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "subject",
                    "inputBinding": {
                        "prefix": "-affinity"
                    },
                    "id": "#gpx_qsubmit.cwl/affinity"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "Directory"
                        }
                    ],
                    "inputBinding": {
                        "prefix": "-asn-cache",
                        "itemSeparator": ","
                    },
                    "id": "#gpx_qsubmit.cwl/asn_cache"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-batch-size"
                    },
                    "id": "#gpx_qsubmit.cwl/batch_size"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "inputBinding": {
                        "prefix": "-db",
                        "valueFrom": "${ var blob = ''; for (var i = 0; i < inputs.blastdb_dir.length; i++) { blob += inputs.blastdb_dir[i].path + '/' + inputs.blastdb[i]; if(i != inputs.blastdb_dir.length-1) blob += ','; } return blob; }"
                    },
                    "id": "#gpx_qsubmit.cwl/blastdb"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "Directory"
                        }
                    ],
                    "id": "#gpx_qsubmit.cwl/blastdb_dir"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "id": "#gpx_qsubmit.cwl/ids"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "ids.mft",
                    "inputBinding": {
                        "prefix": "-ids-manifest"
                    },
                    "id": "#gpx_qsubmit.cwl/ids_manifest"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-lds2"
                    },
                    "id": "#gpx_qsubmit.cwl/lds2"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-max-batch-length"
                    },
                    "id": "#gpx_qsubmit.cwl/max_batch_length"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": true,
                    "inputBinding": {
                        "prefix": "-nogenbank"
                    },
                    "id": "#gpx_qsubmit.cwl/nogenbank"
                },
                {
                    "type": "string",
                    "default": "jobs.xml",
                    "inputBinding": {
                        "prefix": "-o"
                    },
                    "id": "#gpx_qsubmit.cwl/output_xml_jobs"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-overlap"
                    },
                    "id": "#gpx_qsubmit.cwl/overlap"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#gpx_qsubmit.cwl/proteins"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-queries-gc-id-list"
                    },
                    "id": "#gpx_qsubmit.cwl/queries_gc_id_list"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-subjects-gc-id-list"
                    },
                    "id": "#gpx_qsubmit.cwl/subjects_gc_id_list"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-subseq-size"
                    },
                    "id": "#gpx_qsubmit.cwl/subseq_size"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-xml-jobs"
                    },
                    "id": "#gpx_qsubmit.cwl/xml_jobs"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_xml_jobs)"
                    },
                    "id": "#gpx_qsubmit.cwl/jobs"
                }
            ],
            "id": "#gpx_qsubmit.cwl"
        },
        {
            "label": "orf_hits_cache_retrieve",
            "class": "CommandLineTool",
            "baseCommand": "orf_hits_cache_retrieve",
            "arguments": [
                "-nogenbank"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entry": "$(inputs.proteins)",
                            "writable": false
                        },
                        {
                            "entryname": "ids.mft",
                            "entry": "${\n  var blob = '# ids.mft created for orf_hits_cache_retrieve from input \"orfs\" Array of Files' +\n    String.fromCharCode(10) ; \n  for (var i = 0; i < inputs.orfs.length; i++) { \n    blob += inputs.orfs[i].path + String.fromCharCode(10); \n  } \n  return blob; \n}"
                        }
                    ]
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-blast-type"
                    },
                    "id": "#orf_hits_cache_retrieve.cwl/blast_type"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "int"
                        }
                    ],
                    "inputBinding": {
                        "prefix": "-genus-list",
                        "itemSeparator": ","
                    },
                    "id": "#orf_hits_cache_retrieve.cwl/genus_list"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "retrieved_hits.asn",
                    "inputBinding": {
                        "prefix": "-hits-output"
                    },
                    "id": "#orf_hits_cache_retrieve.cwl/hits_output_name"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-lds2"
                    },
                    "id": "#orf_hits_cache_retrieve.cwl/lds2"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "not_found.ids",
                    "inputBinding": {
                        "prefix": "-not-found-output"
                    },
                    "id": "#orf_hits_cache_retrieve.cwl/not_found_output_name"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#orf_hits_cache_retrieve.cwl/orfs"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "ids.mft",
                    "inputBinding": {
                        "prefix": "-orfs-manifest"
                    },
                    "id": "#orf_hits_cache_retrieve.cwl/orfs_manifest"
                },
                {
                    "type": "File",
                    "id": "#orf_hits_cache_retrieve.cwl/proteins"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-blast-hits-sqlite-cache"
                    },
                    "id": "#orf_hits_cache_retrieve.cwl/sqlite_cache"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-taxid"
                    },
                    "id": "#orf_hits_cache_retrieve.cwl/taxid"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-taxon-db"
                    },
                    "id": "#orf_hits_cache_retrieve.cwl/taxon_db"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.hits_output_name)"
                    },
                    "id": "#orf_hits_cache_retrieve.cwl/hits_output"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.not_found_output_name)"
                    },
                    "id": "#orf_hits_cache_retrieve.cwl/not_found_output"
                }
            ],
            "id": "#orf_hits_cache_retrieve.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "file concatenation",
            "baseCommand": "cat",
            "stdout": "cat.out",
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#cat_array_of_files.cwl/files_in"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#cat_array_of_files.cwl/file_out",
                    "outputBinding": {
                        "glob": "cat.out"
                    }
                }
            ],
            "id": "#cat_array_of_files.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "cwl split wrapper",
            "baseCommand": "split",
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-l"
                    },
                    "id": "#split.cwl/chunk_size"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 4
                    },
                    "id": "#split.cwl/input"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "jobs",
                    "inputBinding": {
                        "position": 5,
                        "valueFrom": "$(inputs.mask)"
                    },
                    "id": "#split.cwl/mask"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-n l//",
                        "separate": false
                    },
                    "id": "#split.cwl/nchunks"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": ".xml",
                    "inputBinding": {
                        "position": 3,
                        "separate": false,
                        "prefix": "--additional-suffix="
                    },
                    "id": "#split.cwl/suffix"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "$(inputs.mask)?*$(inputs.suffix)"
                    },
                    "id": "#split.cwl/jobs"
                }
            ],
            "id": "#split.cwl"
        },
        {
            "label": "blastp_wnode_naming",
            "class": "Workflow",
            "requirements": [
                {
                    "class": "SubworkflowFeatureRequirement"
                },
                {
                    "class": "ScatterFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "id": "#main/affinity"
                },
                {
                    "type": "string",
                    "id": "#main/align_filter"
                },
                {
                    "type": "boolean",
                    "id": "#main/allow_intersection"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "Directory"
                    },
                    "id": "#main/asn_cache"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/batch-size"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#main/blast_hits_cache"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#main/blast_type"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#main/blastdb"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "Directory"
                    },
                    "id": "#main/blastdb_dir"
                },
                {
                    "type": "string",
                    "id": "#main/comp_based_stats"
                },
                {
                    "type": "boolean",
                    "id": "#main/compart"
                },
                {
                    "type": "string",
                    "id": "#main/dbsize"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "id": "#main/evalue"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/extra_coverage"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "int"
                    },
                    "id": "#main/genus_list"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/ids"
                },
                {
                    "type": "File",
                    "id": "#main/lds2"
                },
                {
                    "type": "int",
                    "id": "#main/max_batch_length"
                },
                {
                    "type": "int",
                    "id": "#main/max_jobs"
                },
                {
                    "type": "int",
                    "id": "#main/max_target_seqs"
                },
                {
                    "type": "boolean",
                    "id": "#main/no_merge"
                },
                {
                    "type": "boolean",
                    "id": "#main/nogenbank"
                },
                {
                    "type": "string",
                    "id": "#main/ofmt"
                },
                {
                    "type": "File",
                    "id": "#main/proteins"
                },
                {
                    "type": "string",
                    "id": "#main/scatter_gather_nchunks"
                },
                {
                    "type": "string",
                    "id": "#main/seg"
                },
                {
                    "type": "int",
                    "id": "#main/taxid"
                },
                {
                    "type": "File",
                    "id": "#main/taxon_db"
                },
                {
                    "type": "int",
                    "id": "#main/threshold"
                },
                {
                    "type": "int",
                    "id": "#main/top_by_score"
                },
                {
                    "type": "int",
                    "id": "#main/word_size"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": [
                        "#main/collect_aligns/file_out",
                        "#main/retrieve_cached_hits/hits_output"
                    ],
                    "id": "#main/blast_align"
                }
            ],
            "steps": [
                {
                    "run": "#tt_cluster_and_qdump.cwl",
                    "scatter": "#main/cluster_and_qdump/input_jobs",
                    "in": [
                        {
                            "source": "#main/align_filter",
                            "id": "#main/cluster_and_qdump/align_filter"
                        },
                        {
                            "source": "#main/allow_intersection",
                            "id": "#main/cluster_and_qdump/allow_intersection"
                        },
                        {
                            "source": "#main/asn_cache",
                            "id": "#main/cluster_and_qdump/asn_cache"
                        },
                        {
                            "source": "#main/blastdb_dir",
                            "id": "#main/cluster_and_qdump/blastdb_dir"
                        },
                        {
                            "source": "#main/comp_based_stats",
                            "id": "#main/cluster_and_qdump/comp_based_stats"
                        },
                        {
                            "source": "#main/compart",
                            "id": "#main/cluster_and_qdump/compart"
                        },
                        {
                            "source": "#main/dbsize",
                            "id": "#main/cluster_and_qdump/dbsize"
                        },
                        {
                            "source": "#main/evalue",
                            "id": "#main/cluster_and_qdump/evalue"
                        },
                        {
                            "source": "#main/extra_coverage",
                            "id": "#main/cluster_and_qdump/extra_coverage"
                        },
                        {
                            "source": "#main/split_jobs/jobs",
                            "id": "#main/cluster_and_qdump/input_jobs"
                        },
                        {
                            "source": "#main/lds2",
                            "id": "#main/cluster_and_qdump/lds2"
                        },
                        {
                            "source": "#main/max_jobs",
                            "id": "#main/cluster_and_qdump/max_jobs"
                        },
                        {
                            "source": "#main/max_target_seqs",
                            "id": "#main/cluster_and_qdump/max_target_seqs"
                        },
                        {
                            "source": "#main/no_merge",
                            "id": "#main/cluster_and_qdump/no_merge"
                        },
                        {
                            "source": "#main/nogenbank",
                            "id": "#main/cluster_and_qdump/nogenbank"
                        },
                        {
                            "source": "#main/ofmt",
                            "id": "#main/cluster_and_qdump/ofmt"
                        },
                        {
                            "source": "#main/proteins",
                            "id": "#main/cluster_and_qdump/proteins"
                        },
                        {
                            "source": "#main/seg",
                            "id": "#main/cluster_and_qdump/seg"
                        },
                        {
                            "source": "#main/threshold",
                            "id": "#main/cluster_and_qdump/threshold"
                        },
                        {
                            "source": "#main/top_by_score",
                            "id": "#main/cluster_and_qdump/top_by_score"
                        },
                        {
                            "source": "#main/word_size",
                            "id": "#main/cluster_and_qdump/word_size"
                        }
                    ],
                    "out": [
                        "#main/cluster_and_qdump/blast_align"
                    ],
                    "id": "#main/cluster_and_qdump"
                },
                {
                    "run": "#cat_array_of_files.cwl",
                    "in": [
                        {
                            "source": "#main/cluster_and_qdump/blast_align",
                            "id": "#main/collect_aligns/files_in"
                        }
                    ],
                    "out": [
                        "#main/collect_aligns/file_out"
                    ],
                    "id": "#main/collect_aligns"
                },
                {
                    "run": "#gpx_qsubmit.cwl",
                    "in": [
                        {
                            "source": "#main/affinity",
                            "id": "#main/gpx_qsubmit/affinity"
                        },
                        {
                            "source": "#main/asn_cache",
                            "id": "#main/gpx_qsubmit/asn_cache"
                        },
                        {
                            "source": "#main/batch-size",
                            "id": "#main/gpx_qsubmit/batch_size"
                        },
                        {
                            "source": "#main/blastdb",
                            "id": "#main/gpx_qsubmit/blastdb"
                        },
                        {
                            "source": "#main/blastdb_dir",
                            "id": "#main/gpx_qsubmit/blastdb_dir"
                        },
                        {
                            "source": [
                                "#main/retrieve_cached_hits/not_found_output"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#main/gpx_qsubmit/ids"
                        },
                        {
                            "source": "#main/lds2",
                            "id": "#main/gpx_qsubmit/lds2"
                        },
                        {
                            "source": "#main/max_batch_length",
                            "id": "#main/gpx_qsubmit/max_batch_length"
                        },
                        {
                            "source": "#main/nogenbank",
                            "id": "#main/gpx_qsubmit/nogenbank"
                        },
                        {
                            "source": "#main/proteins",
                            "id": "#main/gpx_qsubmit/proteins"
                        }
                    ],
                    "out": [
                        "#main/gpx_qsubmit/jobs"
                    ],
                    "id": "#main/gpx_qsubmit"
                },
                {
                    "run": "#orf_hits_cache_retrieve.cwl",
                    "in": [
                        {
                            "source": "#main/blast_type",
                            "id": "#main/retrieve_cached_hits/blast_type"
                        },
                        {
                            "source": "#main/genus_list",
                            "id": "#main/retrieve_cached_hits/genus_list"
                        },
                        {
                            "source": "#main/lds2",
                            "id": "#main/retrieve_cached_hits/lds2"
                        },
                        {
                            "source": "#main/ids",
                            "id": "#main/retrieve_cached_hits/orfs"
                        },
                        {
                            "source": "#main/proteins",
                            "id": "#main/retrieve_cached_hits/proteins"
                        },
                        {
                            "source": "#main/blast_hits_cache",
                            "id": "#main/retrieve_cached_hits/sqlite_cache"
                        },
                        {
                            "source": "#main/taxid",
                            "id": "#main/retrieve_cached_hits/taxid"
                        },
                        {
                            "source": "#main/taxon_db",
                            "id": "#main/retrieve_cached_hits/taxon_db"
                        }
                    ],
                    "out": [
                        "#main/retrieve_cached_hits/hits_output",
                        "#main/retrieve_cached_hits/not_found_output"
                    ],
                    "id": "#main/retrieve_cached_hits"
                },
                {
                    "run": "#split.cwl",
                    "in": [
                        {
                            "source": "#main/gpx_qsubmit/jobs",
                            "id": "#main/split_jobs/input"
                        },
                        {
                            "source": "#main/scatter_gather_nchunks",
                            "id": "#main/split_jobs/nchunks"
                        }
                    ],
                    "out": [
                        "#main/split_jobs/jobs"
                    ],
                    "id": "#main/split_jobs"
                }
            ],
            "id": "#main"
        },
        {
            "class": "Workflow",
            "label": "cluster_blastp_wnode and gpx_qdump combined",
            "requirements": [
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "id": "#tt_cluster_and_qdump.cwl/align_filter"
                },
                {
                    "type": "boolean",
                    "id": "#tt_cluster_and_qdump.cwl/allow_intersection"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "Directory"
                    },
                    "id": "#tt_cluster_and_qdump.cwl/asn_cache"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "Directory"
                    },
                    "id": "#tt_cluster_and_qdump.cwl/blastdb_dir"
                },
                {
                    "type": "string",
                    "id": "#tt_cluster_and_qdump.cwl/comp_based_stats"
                },
                {
                    "type": "boolean",
                    "id": "#tt_cluster_and_qdump.cwl/compart"
                },
                {
                    "type": "string",
                    "id": "#tt_cluster_and_qdump.cwl/dbsize"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "id": "#tt_cluster_and_qdump.cwl/evalue"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#tt_cluster_and_qdump.cwl/extra_coverage"
                },
                {
                    "type": "File",
                    "id": "#tt_cluster_and_qdump.cwl/input_jobs"
                },
                {
                    "type": "File",
                    "id": "#tt_cluster_and_qdump.cwl/lds2"
                },
                {
                    "type": "int",
                    "id": "#tt_cluster_and_qdump.cwl/max_jobs"
                },
                {
                    "type": "int",
                    "id": "#tt_cluster_and_qdump.cwl/max_target_seqs"
                },
                {
                    "type": "boolean",
                    "id": "#tt_cluster_and_qdump.cwl/no_merge"
                },
                {
                    "type": "boolean",
                    "id": "#tt_cluster_and_qdump.cwl/nogenbank"
                },
                {
                    "type": "string",
                    "id": "#tt_cluster_and_qdump.cwl/ofmt"
                },
                {
                    "type": "File",
                    "id": "#tt_cluster_and_qdump.cwl/proteins"
                },
                {
                    "type": "string",
                    "id": "#tt_cluster_and_qdump.cwl/seg"
                },
                {
                    "type": "int",
                    "id": "#tt_cluster_and_qdump.cwl/threshold"
                },
                {
                    "type": "int",
                    "id": "#tt_cluster_and_qdump.cwl/top_by_score"
                },
                {
                    "type": "int",
                    "id": "#tt_cluster_and_qdump.cwl/word_size"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#tt_cluster_and_qdump.cwl/gpx_qdump/output",
                    "id": "#tt_cluster_and_qdump.cwl/blast_align"
                }
            ],
            "steps": [
                {
                    "run": "#cluster_blastp_wnode.cwl",
                    "in": [
                        {
                            "source": "#tt_cluster_and_qdump.cwl/align_filter",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/align_filter"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/allow_intersection",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/allow_intersection"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/asn_cache",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/asn_cache"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/blastdb_dir",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/blastdb_dir"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/comp_based_stats",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/comp_based_stats"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/compart",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/compart"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/dbsize",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/dbsize"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/evalue",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/evalue"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/extra_coverage",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/extra_coverage"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/input_jobs",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/input_jobs"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/lds2",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/lds2"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/max_jobs",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/max_jobs"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/max_target_seqs",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/max_target_seqs"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/no_merge",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/no_merge"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/nogenbank",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/nogenbank"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/ofmt",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/ofmt"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/proteins",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/proteins"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/seg",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/seg"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/threshold",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/threshold"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/top_by_score",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/top_by_score"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/word_size",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/word_size"
                        },
                        {
                            "default": 1.0,
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/workers_per_cpu"
                        }
                    ],
                    "out": [
                        "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/outdir"
                    ],
                    "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode"
                },
                {
                    "run": "#gpx_qdump.cwl",
                    "in": [
                        {
                            "source": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/outdir",
                            "id": "#tt_cluster_and_qdump.cwl/gpx_qdump/input_path"
                        },
                        {
                            "default": "*",
                            "id": "#tt_cluster_and_qdump.cwl/gpx_qdump/unzip"
                        }
                    ],
                    "out": [
                        "#tt_cluster_and_qdump.cwl/gpx_qdump/output"
                    ],
                    "id": "#tt_cluster_and_qdump.cwl/gpx_qdump"
                }
            ],
            "id": "#tt_cluster_and_qdump.cwl"
        }
    ],
    "cwlVersion": "v1.0"
}
